const $__init__$ = Symbol.for('#__init__'), $__patch__$ = Symbol.for('#__patch__'), $__initor__$ = Symbol.for('#__initor__'), $__inited__$ = Symbol.for('#__inited__'), $__hooks__$ = Symbol.for('#__hooks__');
var $5 = Symbol();
Object.defineProperty(exports, "__esModule", {value: true});

/*body*/
var $1 = require('../Utils/fetch'/*$path$*/);
var $2 = require('../Records/DiscordRecord'/*$path$*/);
var $3 = require('@livy/contracts/lib/formatter-interface'/*$path$*/);
var $4 = require('@livy/util/lib/handlers/abstract-formatting-processing-handler'/*$path$*/);

class DiscordWebhookHandler extends $4.AbstractFormattingProcessingHandler {
	static [$__init__$](){
		this.prototype[$__initor__$] = $5;
		return this;
	}
	[$__patch__$]($$ = {}){
		var $6;
		super[$__patch__$] && super[$__patch__$]($$);
		($6 = $$._webhookUrl) !== undefined && (this._webhookUrl = $6);
		($6 = $$._discordRecord) !== undefined && (this._discordRecord = $6);
		
	}
	[$__init__$]($$ = null,deep = true){
		deep && super[$__init__$] && super[$__init__$](...arguments);
		this._webhookUrl = $$ ? $$._webhookUrl : undefined;
		this._discordRecord = $$ ? $$._discordRecord : undefined;
		
	}
	/**
	@param {string} webhookUrl
	*/
	constructor(webhookUrl,{
		bubble: bubble,
		username: username,
		useEmbed: useEmbed = true,
		avatarUrl: avatarUrl,
		includeContextAndExtra: includeContextAndExtra = false,
		level: level = 'critical',
		excludedFields: excludedFields = [],
		formatter: formatter
	}){
		
		super({level: level,bubble: bubble});
		
		super[$__init__$] || this[$__init__$]();
		this._webhookUrl = webhookUrl;
		this.explicitFormatter = formatter;
		
		this._discordRecord = new $2.DiscordRecord({
			username: username,
			useEmbed: useEmbed,
			avatarUrl: avatarUrl,
			includeContextAndExtra: includeContextAndExtra,
			excludedFields: excludedFields,
			formatter: this.explicitFormatter
		});
		this[$__initor__$]===$5 && (this[$__hooks__$]&&this[$__hooks__$].inited(this),this[$__inited__$] && this[$__inited__$]());
	}
	
	/**
	@returns { DiscordRecord }
	*/
	get discordRecord(){
		
		return this._discordRecord;
	}
	
	/**
	@returns { string }
	*/
	get webhookUrl(){
		
		return this._webhookUrl;
	}
	
	/**
	@param {LogRecord} record
	@returns { Promise<void> }
	*/
	async write(record){
		
		console.log(record);
		// const embeds = [
		// 	{
		// 		title: "Level",
		// 		description: record.level
		// 	}
		// ]
		
		// Object.keys(record.context).forEach do(context)
		// 	embeds.push {
		// 		title: context
		// 		description: record.context[context]
		// 	}
		
		// Object.keys(record.extra).forEach do(extra)
		// 	embeds.push {
		// 		title: extra
		// 		description: record.extra[extra]
		// 	}
		
		// const discordObject = {
		// 	content: record.message,
		// 	embeds: embeds,
		// 	attachments: []
		// }
		
		// if self._username
		// 	discordObject.username = self._username
		
		// if self._avatarUrl
		// 	discordObject.avatar_url = self._avatarUrl
		
		const postData = this._discordRecord.getDiscordData(record);
		const postString = JSON.stringify(postData);
		
		return await $1.fetch(this._webhookUrl,{
			method: 'POST',
			body: postString,
			headers: {
				'Content-Type': 'application/json'
			}
		});
	}
	
	getDefaultFormatter(){
		
		return this._discordRecord.defaultFormatter;
	}
	
	/**
	@param {FormatterInterface} formatter
	*/
	setFormatter(formatter){
		
		return this._discordRecord.formatter = formatter;
	}
	
	getFormatter(){
		
		return this._discordRecord.formatter;
	}
};
exports.DiscordWebhookHandler = DiscordWebhookHandler; DiscordWebhookHandler[$__init__$]();
