Object.defineProperty(exports, "__esModule", {value: true});

/*body*/
var $1 = require('@formidablejs/framework'/*$path$*/);
var $2 = require('@livy/logger'/*$path$*/);
var $3 = require('./Driver'/*$path$*/);
var $4 = require('./Drivers/ConsoleDriver'/*$path$*/);
var $5 = require('./Drivers/DailyDriver'/*$path$*/);
var $6 = require('./Drivers/SingleDriver'/*$path$*/);
var $7 = require('./Drivers/SlackDriver'/*$path$*/);
var $8 = require('./Drivers/StackDriver'/*$path$*/);
var $9 = require('./Drivers/DiscordDriver'/*$path$*/);
var $10 = require('./Exceptions/ConfigMissingException'/*$path$*/);
var $11 = require('./Logger'/*$path$*/);
var $12 = require('./Logger'/*$path$*/);
var $13 = require('./Logger'/*$path$*/);
var $14 = require('./Logger'/*$path$*/);
var $15 = require('./Logger'/*$path$*/);
class LoggerServiceResolver extends $1.ServiceResolver {
	
	
	/**
	@returns { any }
	*/
	get channel(){
		
		const name = this.app.config.get('logging.default');
		
		return this.app.config.get(("logging.channels." + name));
	}
	
	/**
	@returns { HandlerInterface }
	*/
	get handler(){
		
		if (!(this.channel)) {
			
			throw new $10.ConfigMissingException("Logging config is missing");
		};
		
		const driver = $11.get(this.channel.driver);
		
		return (new driver(this.channel)).handler();
	}
	
	boot(){
		
		$3.Driver.setConfig(this.app.config);
		
		$13.register('stack',$8.StackDriver);
		$13.register('single',$6.SingleDriver);
		$13.register('daily',$5.DailyDriver);
		$13.register('console',$4.ConsoleDriver);
		$13.register('slack',$7.SlackDriver);
		$13.register('discord',$9.DiscordDriver);
		
		this.registerChannel();
		
		$12.Log.handlers.add(this.handler);
		
		return $15.registerInstance(this.app.config.get('logging.default'),$12.Log);
	}
	
	registerChannel(){
		var self = this;
		
		const environment = this.app.config.get('app.env','local');
		const loggingMode = this.app.config.get('logging.mode','sync');
		
		// Switch to a different logger
		return $12.Log.channel = function(/**@type {string}*/name,options = {}) {
			var $16;
			
			const instance = $14.getInstance(name);
			
			if (instance) { return instance };
			
			const channel = self.app.config.get(("logging.channels." + name));
			
			if (!channel) {
				
				throw new $10.ConfigMissingException("Logging config is missing");
			};
			
			const driver = $11.get(channel.driver);
			
			const handler = (new driver(channel)).handler();
			
			const logger = new $2.createLogger(environment,{
				mode: (($16 = options.mode) != null) ? ($16) : loggingMode
			});
			
			logger.handlers.add(handler);
			
			$15.registerInstance(name,logger);
			
			return logger;
		};
	}
};
exports.LoggerServiceResolver = LoggerServiceResolver;
